#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
#
# Weitere Lizenz: GPL V3.0
# Siehe http://www.gnu.org/licenses/gpl-3.0.html
#
# $Id: PersonBuchTest.py 680 2014-06-25 21:11:27Z pieper $
#
# PersonBuch.py

class Person:
    def __init__(self,neuerOrt="Buchhandlung",neuesVertrauen="hohes Vertrauen"):
        self.setzeOrt(neuerOrt)
        self.setzeVertrauen(neuesVertrauen)
        self.buecher=list()            
        
    def setzeOrt(self, neuOrt):
        self.ort= neuOrt
            
    def gibOrt(self):
        return self.ort            
            
    def setzeVertrauen(self, neuVertrauen):
        self.vertrauen= neuVertrauen
        
    def gibVertrauen(self):
        return self.vertrauen

    def gibBuecher(self):
        return self.buecher          

    def verkaufeBuch(self, dasBuch):
        if dasBuch in self.buecher:
            self.buecher.remove(dasBuch)
        else:
            print ("Was man nicht hat, kann man nicht verkaufen.")
                               
    def erwirbBuch(self, diesBuch):
        if self.ort=="Buchhandlung":
            if self.gibVertrauen() == "hohes Vertrauen":
                self.buecher.append(diesBuch)
            else:
                print ("Buch sollte nur bei Vertrauen erworben werden.")
        else:
            print ("Ein Buch kann nur in der Buchhandlung erworben werden.")

    def liesBuch(self, diesesBuch):
        if diesesBuch in self.buecher:
            diesesBuch.setzeGelesen(True)
        else:
            print ("Was man nicht hat, kann man nicht lesen.")

    def zeigeBuecher(self,buchliste):
        if buchliste.__len__()== 0:
            return
        else:
            print ("  ",buchliste[0].gibThema(), end=" ")           
            if buchliste[0].gibGelesen():
                print ("- gelesen", )
            else:
                print ("- neuwertig (ungelesen)",)
            self.zeigeBuecher(buchliste[1:])    


class Buch:
    def __init__(self, festesThema):
        self.setzeThema(festesThema)
        self.setzeGelesen(False)        

    def setzeGelesen(self,neuerWert):
        self.gelesen= neuerWert
        
    def gibGelesen(self):
        return self.gelesen
        
    def setzeThema(self, neuesThema):
        self.thema = neuesThema

    def gibThema(self):
        return self.thema
        

if __name__ == "__main__":
    buchhaendlerin = Person("Buchhandlung")

    informatikBuch = Buch("Informatik")
    entspannungsBuch = Buch ("Entspannung")

    buchhaendlerin.erwirbBuch(informatikBuch)
    buchhaendlerin.erwirbBuch(entspannungsBuch)
    print ("buchhaendlerin -- Bücher:")
    buchhaendlerin.zeigeBuecher(buchhaendlerin.gibBuecher())

    kunde= Person("in der Schule")
    kunde.setzeOrt("Buchhandlung")

    kunde.erwirbBuch(entspannungsBuch)
    buchhaendlerin.verkaufeBuch(entspannungsBuch)
    print ("kunde - Bücher:")
    kunde.zeigeBuecher(kunde.gibBuecher())

    print ("buchhaendlerin - Bücher:")
    buchhaendlerin.zeigeBuecher(buchhaendlerin.gibBuecher())

    print("Test: kann kunde ein Buch lesen, das kunde nicht hat?")
    kunde.liesBuch(informatikBuch)

    print ("kunde: erwirbt Informatikbuch")
    kunde.erwirbBuch(informatikBuch)
    buchhaendlerin.verkaufeBuch(informatikBuch)
    print ("kunde - Bücher:")
    kunde.zeigeBuecher(kunde.gibBuecher())
    print ("kunde: liest Informatikbuch")
    kunde.liesBuch(informatikBuch)
    kunde.zeigeBuecher(kunde.gibBuecher())

    print ("buchhaendlerin - Bücher:")
    buchhaendlerin.zeigeBuecher(buchhaendlerin.gibBuecher())

